package sav.example.javaz;
import sav.z.*;
import java.io.*;
/**
 * This example uses the Script class to analyze syntax of Zigzag script.
 * This is also very useful example of Zigzag variable using.
 * The example sequentially prints information about each user.
 */
public class ScriptDemo {
  public static void main(String arg[]) throws IOException {
    Session ss = new Session();
    String text =
      "$base Users ~;" +
      "$readTable() <" +
        "User  ; Name   ; Resource     \n" +
        "ann1  ; Ann    ; data1, data2 \n" +
        "dan   ; Daniel ; data1, data3 \n" +
      ">;"
    ;
    ss.z(text);
    /*Demo1*****************/
    Script scr = new Script("$user = User/(Name:$name);");
    ss.analyse(scr);
    if (!scr.hasErrors()) {
      ss.exploreBase("Users");
      String names[] = { "Ann", "Daniel" };
      for (int i = 0; i < names.length; ++i) {
        ss.var("name").set(names[i]);
//        ss.set("$name", names[i]);
        ss.execute(scr);
        String user = ss.var("user").value();
        System.out.println((i + 1) + " Name: " + names[i] + ", User: " + user);
      }
      ss.closeBase();
    }
    /***********************/
  }
}
